Index: main/plugin-forms/resources/js/org/ametys/forms/FormsListToolFactory.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsListToolFactory.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsListToolFactory.js	(revision 0)
@@ -0,0 +1,33 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.forms.tool');
+
+org.ametys.forms.tool.FormsListToolFactory = function(id, config, pluginName) 
+{
+	org.ametys.forms.tool.FormsListToolFactory.superclass.constructor.call(this, id, config, pluginName);
+};
+
+Ext.extend(org.ametys.forms.tool.FormsListToolFactory, org.ametys.uitool.tool.impl.UniqueInstanceToolFactory,
+{
+	createTool: function (id)
+	{
+		var tool = new org.ametys.forms.tool.FormsListTool(id, this.getPluginName());
+		tool.setConfiguration (this._config);
+		return tool;
+	}
+});
+
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsTool.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsTool.i18n.js	(revision 39963)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsTool.i18n.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -32,7 +32,7 @@
 	    fields: [],
 	    data: []
 	});
-	
+
     this._pagingBar = new Ext.PagingToolbar({
         pageSize: org.ametys.forms.tool.FormsTool.PAGE_SIZE,
         store: store,
@@ -60,22 +60,30 @@
 org.ametys.forms.tool.FormsTool.prototype._sendCurrentSelection = function ()
 {
 	var records = this._resultGrid.getSelectionModel().getSelections();
-
-	var formTarget = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {'id': org.ametys.forms.tool.FormsTool._formId })
+	var hasEntries = this._resultGrid.getStore().getTotalCount() > 0;
+	
+	var formTarget = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {
+			'id': this._formId, 
+			'encodedLabel': this._formEncodedLabel,
+			'hasEntries': hasEntries
+	});
 	
-    for (var i=0; i &lt; records.length; i++)
+    for (var i = 0; i &lt; records.length; i++)
     {
-		formTarget.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': records[i].data.entryId, 'form': org.ametys.forms.tool.FormsTool._formId}));
+		formTarget.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': records[i].data.entryId, 'form': this._formId}));
     }
     
     var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, [formTarget]);
     org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
 }
 
-org.ametys.forms.tool.FormsTool._formId;
+org.ametys.forms.tool.FormsTool.prototype._formId;
+org.ametys.forms.tool.FormsTool.prototype._formEncodedLabel;
 org.ametys.forms.tool.FormsTool.prototype.setParams = function (params)
 {
-	org.ametys.forms.tool.FormsTool._formId = params.id;
+	this._formId = params.id;
+	this._formEncodedLabel = params.encodedLabel;
+	
 	this.refresh();
 }
 
@@ -86,7 +94,7 @@
 	var serverMessage = new org.ametys.servercomm.ServerMessage(
 		'forms',
 		'/form/entries.xml',
-		{siteName: context.parameters.siteName, id: org.ametys.forms.tool.FormsTool._formId, start: 0, limit: 0}, 
+		{siteName: context.parameters.siteName, id: this._formId, start: 0, limit: 0}, 
 		org.ametys.servercomm.ServerComm.PRIORITY_MAJOR,
 		this._displayFormEntries, 
 		this, 
@@ -97,7 +105,7 @@
 
 org.ametys.forms.tool.FormsTool.prototype.onMessage = function (messages)
 {
-    for (var i=messages.length - 1; i &gt;= 0; i--)
+    for (var i = messages.length - 1; i >= 0; i--)
     {
         if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED)
         {
@@ -108,7 +116,7 @@
             {
                 for (var j=0; j &lt; allTargets.length; j++)
                 {
-                    if (org.ametys.forms.tool.FormsTool._formId == allTargets[j].getParameters().form)
+                    if (this._formId == allTargets[j].getParameters().form)
                     {
                     	this.outOfDate(false);
                     	return;
@@ -119,12 +127,16 @@
         else if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_METADATACHANGED)
         {
         	var targets = messages[i].getTargets();
-            var target = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, function(target) { return target.getType() == "content-form";});
+            var contentFormTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, function(target) { return target.getType() == "content-form";});
             
-            if (target != null &amp;&amp; target.getParameters().id == org.ametys.forms.tool.FormsTool._formId)
-            {
-            	this.outOfDate(true);
-            }
+            for (var j = 0; j &lt; contentFormTargets.length; j++)
+        	{
+            	var contentFormTarget = contentFormTargets[j];
+	            if (contentFormTarget != null &amp;&amp; contentFormTarget.getParameters().id == this._formId)
+	            {
+	            	this.outOfDate(true);
+	            }
+        	}
         }
     }
 }
@@ -144,7 +156,7 @@
 	    url: getPluginDirectUrl('forms') + '/form/entries.xml',
 	    record: 'entry',
 	    totalProperty: '@total',
-        baseParams: {siteName: context.parameters.siteName, id: org.ametys.forms.tool.FormsTool._formId}
+        baseParams: {siteName: context.parameters.siteName, id: this._formId}
 	});
 	
 	var colModel = new Ext.grid.ColumnModel({
@@ -163,10 +175,14 @@
 	    params: {
 	        start: 0, 
 	        limit: org.ametys.forms.tool.FormsTool.PAGE_SIZE
-	    }
+	    },
+	    callback: function(){
+	    	this._sendCurrentSelection();
+	    	this.upToDate();
+	    },
+	    scope: this
 	});
 	
-	this.upToDate();
 }
 
 org.ametys.forms.tool.FormsTool.prototype._getFields = function (response)
@@ -400,5 +416,5 @@
 	
 	var fieldId = store.fields.get(colIndex).name;
 	var entryId = record.data.entryId;
-	return "&lt;a class='download' href='" + getPluginDirectUrl('forms') + "/" + context.parameters.siteName + "/download/" + org.ametys.forms.tool.FormsTool._formId + "/" + entryId + "/" + fieldId + "/" + value + "'&gt;" + "&lt;img src='" + iconPath  + "'/&gt;" + value + "&lt;/a&gt;";
+	return "&lt;a class='download' href='" + getPluginDirectUrl('forms') + "/" + context.parameters.siteName + "/download/" + this._formId + "/" + entryId + "/" + fieldId + "/" + value + "'&gt;" + "&lt;img src='" + iconPath  + "'/&gt;" + value + "&lt;/a&gt;";
 }
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsToolFactory.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsToolFactory.js	(revision 39963)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsToolFactory.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -17,11 +17,11 @@
 Ext.namespace('org.ametys.forms.tool');
 
 /**
- * Do not call this constructor. Decalred to and used by the {@see org.ametys.uitool.ToolsManager}
+ * Do not call this constructor. Declared to and used by the {@see org.ametys.uitool.ToolsManager}
  * @constructor
  * @class The factory to creates page tools.
  * @param {String} id The unique id of the factory
- * @param {Map} config Options are : 'url' : the url to use to display page, with a 'path' parameter to place the page path; 'default-location' : where to place the tool; 'description' : the tooltip to display with following parameters 'siteUrl', 'siteTitle', 'lang', 'path'.
+ * @param {Object} config Options are : 'url' : the url to use to display page, with a 'path' parameter to place the page path; 'default-location' : where to place the tool; 'description' : the tooltip to display with following parameters 'siteUrl', 'siteTitle', 'lang', 'path'.
  * @param {String} pluginName The name of the plugin where the factory was declared
  */
 org.ametys.forms.tool.FormsToolFactory = function(id, config, pluginName) 
@@ -34,7 +34,7 @@
 /**
  * Creates a tool of type {@see org.ametys.cms.tool.content.ContentTool} or activate the existing one.
  * There is one tool per content.
- * @param {Map} params The params used by the factory is 'id' that is the content id. Params are transmited the the content tool.
+ * @param {Object} params The params used by the factory is 'id' that is the content id. Parameters are transmitted to the content tool.
  * @return {Ext.org.ametys.uitool.tool.Tool} The tool to open.
  */
 org.ametys.forms.tool.FormsToolFactory.prototype.openTool = function (params)
Index: main/plugin-forms/resources/js/org/ametys/forms/OrphanForms.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/OrphanForms.i18n.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/OrphanForms.i18n.js	(revision 0)
@@ -0,0 +1,129 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.forms.administration.OrphanForms');
+
+org.ametys.forms.administration.OrphanForms.initialize = function (pluginName)
+{
+	org.ametys.forms.administration.OrphanForms.pluginName = pluginName;
+}
+
+org.ametys.forms.administration.OrphanForms.createPanel = function ()
+{
+	// The forms store
+	var store = new Ext.data.SimpleStore({
+		id:0,
+        fields: [
+           {name: 'name'},
+           {name: 'total'}
+        ]
+	});
+	
+	org.ametys.forms.administration.OrphanForms._listView = new org.ametys.ListView({
+        store: store,
+        
+		region: 'center',
+		baseCls: 'orphan-forms-list',
+        
+        viewConfig: {
+        	forceFit: true
+        },
+        
+        columns: [
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_NAME'/>", width: 200, dataIndex: 'name'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_TOTAL'/>", width: 100, dataIndex: 'total'}
+        ]
+    });
+	
+	org.ametys.forms.administration.OrphanForms._listView.addListener('rowclick', org.ametys.forms.administration.OrphanForms._selectTable, org.ametys.forms.administration.OrphanForms);
+	org.ametys.forms.administration.OrphanForms._listView.addListener('mouseup', org.ametys.forms.administration.OrphanForms._unselectTable, org.ametys.forms.administration.OrphanForms);
+	
+	// Actions panel
+	org.ametys.forms.administration.OrphanForms._actions = new org.ametys.ActionsPanel({title: "<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_ACTIONS"/>"});
+	org.ametys.forms.administration.OrphanForms._actions.addAction("<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_ACTIONS_DELETE_TABLE"/>", 
+																	getPluginResourcesUrl(org.ametys.forms.administration.OrphanForms.pluginName) + "/img/administrator/orphan-forms/remove.png", 
+																	org.ametys.forms.administration.OrphanForms.removeTable);
+	org.ametys.forms.administration.OrphanForms._actions.hide(0);
+	
+	// Help panel
+	var helpPanel = new org.ametys.TextPanel({title: "<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_HELP_TITLE"/>"});
+	helpPanel.addText("<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_HELP_TEXT"/>");
+	
+	
+	org.ametys.forms.administration.OrphanForms._rightPanel = new org.ametys.HtmlContainer({
+		region:'east',
+		cls: 'admin-right-panel',
+		width: 277,
+	    items: [org.ametys.forms.administration.OrphanForms._actions, helpPanel]
+	});
+}
+
+org.ametys.forms.administration.OrphanForms.addElement = function (id, name, total)
+{
+	org.ametys.forms.administration.OrphanForms._listView.addElement(id, {
+		'name': name,
+		'total': total
+	});	
+}
+
+org.ametys.forms.administration.OrphanForms.removeTable = function ()
+{
+	Ext.Msg.confirm("<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_ACTIONS_DELETE_TABLE_TITLE"/>", 
+			"<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_ACTIONS_DELETE_TABLE_TITLE_TEXT"/>", 
+			org.ametys.forms.administration.OrphanForms.doRemove, 
+			this
+	);
+}
+
+org.ametys.forms.administration.OrphanForms.doRemove = function (button)
+{
+	if (button == 'yes')
+	{
+		org.ametys.forms.administration.OrphanForms._mask = new org.ametys.msg.Mask();
+		
+		var record = org.ametys.forms.administration.OrphanForms._listView.getSelectionModel().getSelected();
+		
+		var serverMessage = new org.ametys.servercomm.ServerMessage('forms', 'administrator/delete-form', {'name': record.get('name')}, org.ametys.servercomm.ServerComm.PRIORITY_MAJOR, org.ametys.forms.administration.OrphanForms._doRemoveCb, this, [record]);
+		org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
+	}
+}
+org.ametys.forms.administration.OrphanForms._doRemoveCb = function (response, args)
+{
+	org.ametys.forms.administration.OrphanForms._mask.hide();
+	
+	if (org.ametys.servercomm.ServerComm.handleBadResponse("<i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_ACTIONS_DELETE_TABLE_ERROR"/>", response, "org.ametys.forms.administration.OrphanForms.remove"))
+	{
+		return;
+	}
+	
+	Ext.each(args[0], function(record){
+		org.ametys.forms.administration.OrphanForms._listView.getStore().remove(record);
+	});
+}
+
+org.ametys.forms.administration.OrphanForms._selectTable = function(grid, rowIndex, event)
+{
+	org.ametys.forms.administration.OrphanForms._actions.show();
+}
+
+org.ametys.forms.administration.OrphanForms._unselectTable = function(event)
+{
+	org.ametys.forms.administration.OrphanForms._actions.hide();
+}
+
+
+
+
Index: main/plugin-forms/sitemap.xmap
===================================================================
--- main/plugin-forms/sitemap.xmap	(revision 39963)
+++ main/plugin-forms/sitemap.xmap	(working copy)
@@ -26,6 +26,9 @@
             <map:generator name="results" src="org.ametys.plugins.forms.processing.FormResultsGenerator" logger="org.ametys.plugins.forms.processing.FormResultsGenerator"/>
             <map:generator name="receipt" src="org.ametys.plugins.forms.processing.FormResultsGenerator" logger="org.ametys.plugins.forms.processing.FormResultsGenerator"/>
 
+            <map:generator name="forms-list" src="org.ametys.plugins.forms.data.FormsListGenerator" logger="org.ametys.plugins.forms.data.FormsListGenerator"/>
+        
+            <map:generator name="administrator-orphan-forms" src="org.ametys.plugins.forms.OrphanFormsGenerator" logger="org.ametys.plugins.forms.OrphanFormsGenerator"/>
         </map:generators>
         
         <map:actions>
@@ -36,6 +39,9 @@
             <map:action name="delete-form-entries" src="org.ametys.plugins.forms.DeleteFormEntriesAction" logger="org.ametys.plugins.forms.DeleteFormEntriesAction"/>
             
             <map:action name="set-header" src="org.apache.cocoon.acting.HttpHeaderAction"/>
+            
+            <map:action name="administrator-is-system-user" src="org.ametys.runtime.plugins.core.right.actions.IsAdminAction" logger="org.ametys.runtime.plugins.web.administrator.sitemap.action.isAdmin"/>
+            <map:action name="delete-form" src="org.ametys.plugins.forms.DeleteFormTableAction" logger="org.ametys.plugins.forms.DeleteFormTableAction"/>
         </map:actions>
         
         <map:serializers>
@@ -219,7 +225,6 @@
                 </map:act>
             </map:match>
             
-            
             <map:match pattern="form/entries-statement.xml">
                 <map:generate type="form-entries-statement">
                     <map:parameter name="site" value="{request-param:siteName}"/>
@@ -228,6 +233,40 @@
                 <map:serialize type="xml"/>
             </map:match>
             
+            <map:match pattern="forms-list.xml">
+                <map:generate type="forms-list">
+                    <map:parameter name="siteName" value="{request-param:siteName}"/>
+                    <map:parameter name="language" value="{request-param:language}"/>
+                </map:generate>
+                <map:serialize type="xml"/>
+            </map:match>
+            
+            <!-- ********************* ADMIN ************************* -->
+            <map:match pattern="administrator/**">
+                <map:act type="administrator-is-system-user"/>
+            </map:match>
+            
+            <map:match pattern="administrator/orphan-forms/view.html">
+                <map:generate type="administrator-orphan-forms" label="content"/>
+                <map:transform type="xslt" src="pages/administrator/orphan-forms/view.xsl">
+                    <map:parameter name="contextPath" value="{request:contextPath}"/>
+                    <map:parameter name="pluginName" value="forms"/>
+                    <map:parameter name="workspaceName" value="{request-attr:workspaceName}"/>
+                    <map:parameter name="workspaceURI" value="{request-attr:workspaceURI}"/>
+                </map:transform>
+                <map:transform type="i18n">
+                    <map:parameter name="locale" value="{locale:locale}"/>
+                    <map:parameter name="plugin" value="{request-attr:pluginName}"/>
+                </map:transform>
+                <map:serialize type="xml"/>
+            </map:match>
+            
+            <map:match pattern="administrator/delete-form">
+                <map:act type="delete-form">
+                    <map:generate type="action-result"/>
+                    <map:serialize type="xml"/>
+                </map:act>
+            </map:match>
         </map:pipeline>
 	</map:pipelines>
 </map:sitemap>
Index: main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormEntriesAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormEntriesAction.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormEntriesAction.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2015 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -15,7 +15,6 @@
  */
 package org.ametys.plugins.forms;
 
-import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
@@ -27,6 +26,7 @@
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.collections.CollectionUtils;
 import org.apache.commons.lang.StringUtils;
 
 import org.ametys.plugins.forms.jcr.FormPropertiesManager;
@@ -48,41 +48,43 @@
         _formTableManager = new FormTableManager();
     }
     
+    @SuppressWarnings("unchecked")
     @Override
     public Map<String, String> act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
     {
-        Map<String, String> result = new HashMap<String, String>();
         Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
 
         String mode = parameters.getParameter("mode");
         String siteName = (String) jsParameters.get("siteName");
-        String formId = (String) jsParameters.get("formId");
+        List<String> formIds = (List<String>) jsParameters.get("formIds");
         
-        if (StringUtils.isEmpty(siteName) || StringUtils.isEmpty(formId))
+        if (StringUtils.isEmpty(siteName) || CollectionUtils.isEmpty(formIds))
         {
             throw new ProcessingException("The site name and form ID must be provided.");
         }
-    
-        Form form = _formPropertiesManager.getForm(siteName, formId);
         
-        if (form == null)
+        for (String formId : formIds)
         {
-            throw new ProcessingException("The form of ID '" + formId + " can't be found in the site '" + siteName + "'.");
-        }
-        
-        if (mode.equals("delete"))
-        {
-            List<Integer> entriesIds = (List<Integer>) jsParameters.get("ids");
-            for (Integer entryId : entriesIds)
+            Form form = _formPropertiesManager.getForm(siteName, formId);
+            if (form == null)
             {
-                _formTableManager.deleteSubmission(form, entryId);
+                throw new ProcessingException("The form of ID '" + formId + " can't be found in the site '" + siteName + "'.");
             }
-        }
-        else if (mode.equals("clear"))
-        {
-            _formTableManager.deleteSubmission(form, null);
+            
+            if (mode.equals("delete"))
+            {
+                List<Integer> entriesIds = (List<Integer>) jsParameters.get("ids");
+                for (Integer entryId : entriesIds)
+                {
+                    _formTableManager.deleteSubmission(form, entryId);
+                }
+            }
+            else if (mode.equals("clear"))
+            {
+                _formTableManager.deleteSubmission(form, null);
+            }
         }
         
-        return result;
+        return EMPTY_MAP;
     }
 }
Index: main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormTableAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormTableAction.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/DeleteFormTableAction.java	(revision 0)
@@ -0,0 +1,53 @@
+/*
+ * Copyright 2016 Anyware Services
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License"); you may not
+ * use this file except in compliance with the License. You may obtain a copy of
+ * the License at
+ *
+ * http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+ * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+ * License for the specific language governing permissions and limitations under
+ * the License.
+ */
+package org.ametys.plugins.forms;
+
+import java.util.Map;
+
+import org.apache.avalon.framework.activity.Initializable;
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.cocoon.acting.AbstractAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.SourceResolver;
+
+import org.ametys.plugins.forms.table.FormTableManager;
+
+/**
+ * Delete a list of forms' tables
+ */
+public class DeleteFormTableAction extends AbstractAction implements Initializable
+{
+    /** The manager for form SQL Tables */
+    private FormTableManager _formTableManager;
+    
+    @Override
+    public void initialize() throws Exception
+    {
+        _formTableManager = new FormTableManager();
+    }
+    
+    @SuppressWarnings("unchecked")
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
+        String tableName = (String) jsParameters.get("name");
+        
+        _formTableManager.dropTable(tableName);
+        
+        return EMPTY_MAP;
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/OrphanFormsGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/OrphanFormsGenerator.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/OrphanFormsGenerator.java	(revision 0)
@@ -0,0 +1,81 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms;
+
+import java.io.IOException;
+import java.util.List;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.xml.sax.SAXException;
+
+import org.ametys.plugins.forms.jcr.FormPropertiesManager;
+import org.ametys.plugins.forms.table.FormTableManager;
+
+/**
+ * Generator listing all of the forms that are no longer referenced by any content
+ */
+public class OrphanFormsGenerator extends ServiceableGenerator
+{
+    /** Component gathering methods to query forms in JCR */
+    FormPropertiesManager _formPropertiesManager;
+    
+    /** Component gathering methods to manipulate SQL forms */
+    FormTableManager _formTableManager;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
+        _formTableManager = new FormTableManager();
+    }
+    
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        try
+        {
+            String formId = null;
+            Form form = null;
+            AttributesImpl attrs = new AttributesImpl();
+            
+            List<String> tableNames = _formTableManager.getTableNames();
+            contentHandler.startDocument();
+            for (String tableName : tableNames)
+            {
+                formId = tableName.substring(FormTableManager.TABLE_PREFIX.length()); 
+                form = _formPropertiesManager.getForm(formId);
+                if (form == null)
+                {
+                    attrs.addCDATAAttribute("name", tableName);
+                    attrs.addCDATAAttribute("total", Integer.toString(_formTableManager.getTotalSubmissions(formId)));
+                    
+                    XMLUtils.createElement(contentHandler, "table", attrs);
+                    
+                    attrs.clear();
+                }
+            }
+            contentHandler.endDocument();
+        }
+        catch (Exception e)
+        {
+            throw new ProcessingException("An error occurred while retrieving the orphan forms.", e);
+        }
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/ContentFormsGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/ContentFormsGenerator.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/ContentFormsGenerator.java	(working copy)
@@ -57,6 +57,7 @@
     }
     
     @Override
+    @SuppressWarnings("unchecked")
     public void generate() throws IOException, SAXException, ProcessingException
     {
         Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/FormEntriesGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/FormEntriesGenerator.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/FormEntriesGenerator.java	(working copy)
@@ -93,7 +93,7 @@
             
             Map<String, FieldValue> columns = _formTableManager.getColumns(form);
             List<UserEntry> entries = _formTableManager.getSubmissions(form, columns, start, limit);
-            int totalSubmissions = _formTableManager.getTotalSubmissions(form);
+            int totalSubmissions = _formTableManager.getTotalSubmissions(form.getId());
             
             contentHandler.startDocument();
             
@@ -133,8 +133,8 @@
         }
         catch (FormsException e)
         {
-            getLogger().error("An error occurred while getting the results of a form.", e);
-            throw new ProcessingException("An error occurred while getting the results of a form.", e);
+            getLogger().error("An error occurred while getting the entries of a form.", e);
+            throw new ProcessingException("An error occurred while getting the entries of a form.", e);
         }
     }
     
